#include <mega8.h>
#include <delay.h>

// Declare your global variables here
unsigned char s,m,a1,i,n,n1=1,nk=0xff;   
unsigned int  x,x1,t1,z4=0;  
float z3=0,z2=0,z0=0,z1=0,x2=1; 
eeprom unsigned int t;//0   1    2   3    4    5    6    7    8    9    10   11
unsigned char k[12]={0x28,0xaf,0x98,0x0a,0x0f,0x0a,0x08,0xae,0x08,0x0a,0xff,0xff} ;
unsigned char k2[12]={0x00,0x10,0x10,0x10,0x00,0x08,0x08,0x10,0x00,0x00,0x18,0x18} ;//0x18 9 02 00  h 08
unsigned char k1[5]={0xfe,0x40,0x20,0x02,0x80} ;

interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here 6943     6945000   4394531
z1=(4395631/x2);
z2=z2+1; // 
x2=0;
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here    31.83 e-6    31256  0,000032  27783,111111111111111111111111111   PORTC.2=~PORTC.2  ;
//3906,25 g  15625- 4 
x2=x2+1; x1=x1+1;
}

interrupt [TIM2_OVF] void timer2_ovf_isr(void)        //8000000 /128= 62500 /256 =244,140625 g =>0,004096 c   1.125-1=> 0.88888889g =>217 r 217,01388888888888888888888888889
{
       {         
        n++;if(n==5)n=1;
        if(n==4){m=(x)%10;}
        if(n==3){m=(x/(10))%10;}
        if(n==2){m=(x/(100))%10;}
        if(n==1){m=(x/(1000))%10;};
        PORTD=k1[n]&nk;
        PORTD=PORTD|(k2[m]);PORTB=(k[m]); if (n==n1)PORTB.3=0;else PORTB.3=1; 
         
        }
//PORTB.4=~PORTB.4;
// Place your code here

}



void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port C initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTC=0xFF;
DDRC=0x00;   //DDRC.2=1;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTD=0xFF;
DDRD=0xff;
DDRD.2=0;//DDRC.3=1;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

/*TCCR2A=0x02;
TCCR2B=0x07;
TCNT2=0x00;
OCR2A=0x10;
OCR2B=0x00;
             */
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
GICR|=0x40;
MCUCR=0x02;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

#asm("sei")

while (1)
      { 
      if(x1>10000)
      {
      z3=(z2/3.2);  
      if(z3<10000){x=z3;n1=1;}
      if(z3>=10000&z3<100000){x=z3/10;n1=2;}
      if(z3>=100000&z3<1000000){x=z3/100;n1=3;}
      if(z3>=1000000&z3<10000000){x=z3/1000;n1=4;}
      if(x1>15625){x1=0;x=z1;n1=1;}
      }
      if(PINC.0==0){z2=0;delay_ms(100);} 
      if(x2>4395631)z1=0;
      };                                                 
}